/*	Example program showing multiple GL scenes with only one X window with one GLXContext	*/
/*	Compile:
		cc gltest2.c -o gltest2 -lGL -lGLU -lX11 -L/usr/X11R6/include
		
	optionaly flags: -DWINS=number_of_windows, from 4 to 100
					 -DWIDTH=main_window_width
					 -DHEIGHT=main_window_height
*/

/*
	CAUTION:
	You read this source code on your own risk. I was writing it fast, repeatelly
	comment and uncomment many lines, making unnecessary variables and functions,
	writing it 'very not optimized' and so on. Of course I can write clear 
	codes, but my priorytet was to quickly show you that it can work (only the
	mechanism it use).
*/

#include  <GL/glx.h>
#include  <GL/gl.h>
#include  <GL/glu.h>
#include  <unistd.h>
#include  <stdlib.h>
#include  <string.h>
#include <stdio.h>

GLXContext globalcx;

#ifndef WIDTH
#define WIDTH	1000
#endif
#ifndef HEIGHT
#define	HEIGHT	700
#endif
/*	structur to remember child window position and dimmension	*/
struct _CONTEXT
{
	int vx,vy,vw,vh;
	int x,y,w,h;
	Pixmap pix;
	GLXPixmap glpix;
	GLXContext cx;
	GLXPixmap mask;
};
typedef struct _CONTEXT CONTEXT;
CONTEXT *cur;


struct _WINDOW
{
	char name[32];
	
	/*	non-client area parameters */
	XRectangle rect;
	
	/*	client area parameters	*/
	XRectangle client;
	
	Pixmap mask;
	int updated;
	
	struct _WINDOW *prev;
	struct _WINDOW *next;
};

typedef struct _WINDOW WINDOW;

WINDOW *wndlist=NULL;
WINDOW *topmost=NULL;

GC maskgc;
Pixmap mask;
XRectangle dirty;

float angle=0;
Display *dpy;
Window win;
int width,height;
GC gc;


int RectInRect(XRectangle *r1,XRectangle *r2)
{
	return (r1->x<r2->width+r2->x)&&(r2->x<r1->width+r1->x)
		&&(r1->y<r2->height+r2->y)&&(r2->y<r1->height+r1->y);
}

void update_mask(WINDOW *wnd)
{
	WINDOW *ptr;
	int x,y,w,h;
	ptr = wnd->next;
	XSetForeground(dpy,maskgc,0);
	XFillRectangle(dpy,wnd->mask,maskgc,0,0,wnd->rect.width,wnd->rect.height);
	
	XSetForeground(dpy,maskgc,1);
	XFillArc(dpy,wnd->mask,maskgc,0,0,wnd->rect.width,wnd->rect.height,0,360*64);
	//XFillRectangle(dpy,wnd->mask,maskgc,0,0,wnd->rect.width,wnd->rect.height);
	XSetForeground(dpy,maskgc,0);
//	printf("%d %d %d %d\n",wnd->rect.x,wnd->rect.y,wnd->rect.width,wnd->rect.height);
	while(ptr != NULL)
	{
	//	printf("%d %d %d %d\n",ptr->rect.x,ptr->rect.y,ptr->rect.width,ptr->rect.height);
		if(RectInRect(&ptr->rect,&wnd->rect))
		{
//			printf("%%\n");
//			printf("%d %d %d %d\n");
			x = ptr->rect.x-wnd->rect.x;
			y = ptr->rect.y-wnd->rect.y;
			w = ptr->rect.width;
			h = ptr->rect.height;
			/*if(x<0)
			{
				w+=x;
				x = 0;
			}
			if(y<0)
			{
				h+=y;
				y = 0;
			}
			if(x+w>wnd->rect.width+wnd->rect.x)
				w = wnd->rect.width;
			if(h>wnd->rect.height)
				h = wnd->rect.height;*/
			XFillArc(dpy,wnd->mask,maskgc,x,y,w,h,0,360*64);
			//XFillRectangle(dpy,wnd->mask,maskgc,x,y,w,h);
		}
		ptr = ptr->next;
	}
//	printf("\n");
	wnd->updated = 1;
}

void GetDC(WINDOW *wnd)
{
	XSetForeground(dpy,maskgc,0);
	XFillRectangle(dpy,mask,maskgc,dirty.x,dirty.y,dirty.width,dirty.height);
	
	if(!wnd->updated)
		update_mask(wnd);
	
	XCopyArea(dpy,wnd->mask,mask,maskgc,0,0,
		wnd->rect.width,wnd->rect.height,wnd->rect.x,
		wnd->rect.y);
	
	dirty = wnd->rect;
	XSetClipMask(dpy,gc,mask);
}

void GetWindowDC(WINDOW *wnd)
{
	XSetForeground(dpy,maskgc,0);
	XFillRectangle(dpy,mask,maskgc,dirty.x,dirty.y,dirty.width,dirty.height);
	
	if(!wnd->updated)
		update_mask(wnd);
	
	XCopyArea(dpy,wnd->mask,mask,maskgc,0,0,wnd->rect.width,wnd->rect.height,
		wnd->rect.x,wnd->rect.y);
	dirty = wnd->rect;

	XSetForeground(dpy,maskgc,0);
	XFillRectangle(dpy,mask,maskgc,wnd->rect.x+wnd->client.x,
		wnd->rect.y+wnd->client.y,wnd->rect.x+wnd->client.width,
		wnd->rect.y+wnd->client.height);	
	XSetClipMask(dpy,gc,mask);
}

WINDOW *create_window(const char *name,int x,int y,int w,int h)
{
	WINDOW *wnd = (WINDOW*)malloc(sizeof(WINDOW));
	wnd->rect.x = x;
	wnd->rect.y = y;
	wnd->rect.width = w;
	wnd->rect.height = h;
	wnd->client.x = 2;
	wnd->client.y = 20;
	wnd->client.width = w-4;
	wnd->client.height = h-22;
	
	strcpy(wnd->name,name);
	wnd->updated = 0;
	wnd->mask = XCreatePixmap(dpy,win,w,h,1);
	
	wnd->prev = topmost;
	wnd->next = NULL;
	if(wndlist==NULL)
		wndlist = wnd;
	if(topmost!=NULL)
		topmost->next = wnd;
	topmost = wnd;
	return wnd;
}

WINDOW *findwndxy(int x,int y)
{
	WINDOW *ptr;
	ptr = topmost;
	while(ptr)
	{
		if((ptr->rect.x<=x)&&(ptr->rect.y<=y)&&(ptr->rect.x+ptr->rect.width>=x)
			&&(ptr->rect.y+ptr->rect.height>=y))
			break;
		ptr = ptr->prev;
	}
	return ptr;
}

void bringup(WINDOW *wnd)
{
	WINDOW *ptr;
	if(topmost!=wnd)
	{
		ptr = wnd->next;
		if(wnd->prev==NULL)
		{
			wndlist = wndlist->next;
			if(wndlist)
				wndlist->prev = NULL;
		}
		else
		{
			wnd->prev->next = wnd->next;
			wnd->next->prev = wnd->prev;
		}
		wnd->prev = topmost;
		wnd->next = NULL;
		topmost->next = wnd;
		topmost = wnd;
		while(ptr!=NULL)
		{
			if(RectInRect(&ptr->rect,&wnd->rect))
				ptr->updated = 0;
			ptr = ptr->next;
		}
	}

}
/*
	1. Clip region
		a. Clear global mask last painted region
		b. Find all window which intersects
		c. Draw their region on globalmask
	2. if(GL)DrawOnPixmap;CopyArea;
	3. else Draw;
*/

/*	background colors of windows	*/
float colors[100][3]={{0,0,0},{1,0,0},{0,1,0},{0,0,1}};
int kolory[16]={0x0,0xff0000,0x00ff00,0x0000ff};

void myglViewport(int x,int y,int w,int h)
{
	cur->vx = cur->x+x;
	cur->vy = cur->y+y;
	cur->vw = w;
	cur->vh = h;
	glViewport(0,0,w,h);//cur->x+x,cur->y+y,w,h);
	glScissor(cur->vx,cur->vy,w,h);
	glEnable(GL_SCISSOR_TEST);
}

void myglMakeCurrent(CONTEXT *ctx)
{
	cur = ctx;
	glViewport(cur->vx,cur->vy,cur->vw,cur->vh);
	glScissor(cur->vx,cur->vy,cur->vw,cur->vh);
	glEnable(GL_SCISSOR_TEST);
	
	/*	this will be later saved somehow in CONTEXT	*/
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(120,(GLfloat)cur->vw/(GLfloat)cur->vh,0.1,10);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

CONTEXT initgl(int x,int y,int w,int h)
{
	CONTEXT cx,*ptr;
	cx.x = 0;cx.y=0;cx.w=w;cx.h=h;
	ptr = cur;	
	cur = &cx;
	myglViewport(0,0,w,h);
	cur = ptr;
	
	return cx;
}

void dopix(CONTEXT *cx,Display *dpy,Window win,XVisualInfo *vi)
{
	cx->pix = XCreatePixmap(dpy,win,cx->w,cx->h,vi->depth);
	cx->glpix = glXCreateGLXPixmap(dpy,vi,cx->pix);
	//cx->cx = glXCreateContext(dpy,vi,0,0);
}



/*	window draw function, it can be different for each window	*/
void Draw(CONTEXT *cx,int i)
{
	myglMakeCurrent(cx);
	glXMakeCurrent(dpy,cx->glpix,globalcx);
	glLoadIdentity();
	gluLookAt(0,0,0.5,0,0,-0.5,0,1,0);
	glClearColor(colors[i][0],colors[i][1],colors[i][2],0);
	glClear(GL_COLOR_BUFFER_BIT);
	glTranslatef(0,0,-1);
	glRotatef(angle,0,1,0);
	glTranslatef(0,0,1);
	glBegin(GL_TRIANGLES);
		glColor3f(1,0,0);
		glVertex3f(1,0,-1);
		glColor3f(0,1,0);
		glVertex3f(-1,0,-1);
		glColor3f(0,0,1);
		glVertex3f(0,1,-1);
	glEnd();
	
}



Bool WaitForNotify(Display *d, XEvent *e, char *arg)
{
	return (e->type == MapNotify) && (e->xmap.window == (Window)arg);
}

#ifndef WINS
#define WINS		8
#endif
int main(int argc, char **argv)
{
	XSetWindowAttributes swa;
	XEvent report;
	int i,end=0;
	Colormap cmap;
	GLXContext cx;
	XEvent event;
	int attributeList[] = { GLX_RGBA, /*GLX_DOUBLEBUFFER, GLX_DEPTH_SIZE, 16,*/ None };
	XVisualInfo *vi;
	WINDOW *mywins[WINS];
	XMotionEvent motion;
	XButtonEvent button;
	XRectangle xrect;
	WINDOW *wnd,*ptr;
	
	CONTEXT cxs[WINS];
	int state=0;
	int x,y,w,h;
	
	dpy = XOpenDisplay(0);
	vi = glXChooseVisual(dpy, DefaultScreen(dpy), attributeList);
	
	cmap = XCreateColormap(dpy, RootWindow(dpy, vi->screen),
	vi->visual, AllocNone);

	/* create a window */
	swa.colormap = cmap;
	swa.border_pixel = 0;
	swa.event_mask = StructureNotifyMask|KeyReleaseMask|PointerMotionMask|ButtonPressMask|ButtonReleaseMask;

	win = XCreateWindow(dpy, RootWindow(dpy, vi->screen), 0, 0, WIDTH,HEIGHT,
			0, vi->depth, InputOutput, vi->visual,
			CWBorderPixel|CWColormap|CWEventMask, &swa);

	/* create a GLX context, only one */
	gc = XCreateGC(dpy, win, 0, NULL);
	globalcx = cx = glXCreateContext(dpy, vi, 0, GL_FALSE);

	width = WIDTH;
	height = HEIGHT;
	dirty.x = 0;
	dirty.y = 0;
	dirty.width = WIDTH;
	dirty.height = HEIGHT;
	
 	mask = XCreatePixmap(dpy,win,WIDTH,HEIGHT,1);
	maskgc = XCreateGC(dpy,mask,0,NULL);
	XSetForeground(dpy,maskgc,1);
	XFillRectangle(dpy,mask,maskgc,50,50,320,240);
	glXMakeCurrent(dpy,win,cx);

	XMapWindow(dpy, win);

	/*	create virtuall sub-windows	*/
	for(i=4;i<WINS;i++)
	{
		colors[i][0] = (double)rand()/RAND_MAX;
		colors[i][1] = (double)rand()/RAND_MAX;
		colors[i][2] = (double)rand()/RAND_MAX;
	}
	mywins[0] = create_window("Window1",00,00,320,240);
	mywins[2] = create_window("Window2",0,240,320,240);
	mywins[3] = create_window("Window3",120,240,320,240);
	mywins[1] = create_window("Window4",220,0,320,240);
	for(i=4;i<WINS;i++)
	{
		x = rand()%(WIDTH-320);
		y = rand()%(HEIGHT-240);
		w = (rand()%220)+100;
		h = (rand()%140)+100;
		mywins[i] = create_window("small",x,y,w,h);
	}
	/*cxs[0] = initgl(0,0,320,120);
	cxs[1] = initgl(320,0,320,120);
	cxs[2] = initgl(0,120,320,120);
	cxs[3] = initgl(160,120,160,120);*/
	for(i=0;i<WINS;i++)
		cxs[i] = initgl(mywins[i]->rect.x,mywins[i]->rect.y,
			mywins[i]->rect.width,mywins[i]->rect.height);
	for(i=0;i<WINS;i++)
	dopix(&cxs[i],dpy,win,vi);
	
	XSetForeground(dpy,maskgc,0);
	XFillRectangle(dpy,mask,maskgc,0,0,WIDTH,HEIGHT);
	XIfEvent(dpy, &event, WaitForNotify, (char*)win);
	XSetForeground(dpy,gc,0x00ff00);
	XSetClipMask(dpy,gc,mask);
	i=0;
	while(!end)
	{
		if(XPending(dpy))
		{
			XNextEvent(dpy,&report);
			if(report.type == KeyRelease)
			{	
				end = 1;
			/*	if(XKeycodeToKeysym(dpy,report.xkey.keycode,0)=='e')				
				end=1;
				ptr = wndlist;*/
			/*	
				printf("Topmost: %s\nWndlist: %s\n",topmost->name,wndlist->name);
				while(ptr)
				{
					printf("%s\n",ptr->name);
					ptr = ptr->next;
				}
				printf("\n");
				*/
			}
			else if(report.type == MotionNotify)
			{
				motion = report.xmotion;
				if((state)&&(wnd!=NULL))
				{
					x = motion.x-x;
					y = motion.y-y;
					ptr = wndlist;
					xrect = wnd->rect;
					wnd->rect.x+=x;
					wnd->rect.y+=y;
					while(ptr!=NULL)
					{
						if((RectInRect(&ptr->rect,&wnd->rect)||RectInRect(&ptr->rect,&xrect))&&(ptr!=wnd))
						{
							ptr->updated = 0;
						}
						ptr = ptr->next;
					}
					x = motion.x;
					y = motion.y;
				}
				//printf("x:%d y:%d\n",motion.x,motion.y);
			}
			else if(report.type == ButtonPress)
			{
				state = 1;
				button = report.xbutton;
//				printf("pressed\n");
				wnd = findwndxy(button.x,button.y);
				x = button.x;
				y = button.y;
				if(wnd)
					bringup(wnd);
				
			}
			else if(report.type == ButtonRelease)
			{
				state = 0;
				button = report.xbutton;
				//printf("released\n");
			}
		}
		else
		{
			i = i%WINS;

			if(i==0)
			{
				ptr = wndlist;
				XSetForeground(dpy,maskgc,1);
				XFillRectangle(dpy,mask,maskgc,0,0,WIDTH,HEIGHT);
				while(ptr)
				{
					if(!ptr->updated)
						update_mask(ptr);
					ptr = ptr->next;
				}				
				ptr = wndlist;
				XSetFunction(dpy,maskgc,GXandInverted);
				
				while(ptr)
				{
					XCopyArea(dpy,ptr->mask,mask,maskgc,0,0,
						ptr->rect.width,ptr->rect.height,
						ptr->rect.x,ptr->rect.y);
					ptr = ptr->next;					
				}
				XSetFunction(dpy,maskgc,GXcopy);
				XSetClipMask(dpy,gc,mask);
				XSetForeground(dpy,gc,0xffffff);
				XFillRectangle(dpy,win,gc,0,0,WIDTH,HEIGHT);
				dirty.x=0;dirty.y=0;dirty.width=WIDTH;dirty.height=HEIGHT;
			}
				GetDC(mywins[i]);
				//XSetForeground(dpy,gc,kolory[i]);
				//XFillRectangle(dpy, win, gc, mywins[i]->rect.x, mywins[i]->rect.y,
//					mywins[i]->rect.x+mywins[i]->rect.width,
	//				mywins[i]->rect.y+mywins[i]->rect.height);
				
			
			angle+=0.2;
			//for(i=0;i<4;i++)
				Draw(&cxs[i],i);
				XCopyArea(dpy,cxs[i].pix,win,gc,0,0,
					mywins[i]->rect.x+mywins[i]->rect.width,
					mywins[i]->rect.y+mywins[i]->rect.height,
					mywins[i]->rect.x, mywins[i]->rect.y);
			i++;
			//glXSwapBuffers(dpy,win);
		}
	}

	glXDestroyContext(dpy,cx);

	return 0;
}

